var storage = new technalxs.simplemail.SimpleMailStorageManager.SimpleMailStorage();

// OnLoad event fires twice when iframe is present (FF bug)

if(typeof(technalxs) == "undefined") {var technalxs = {};};
if(typeof(technalxs.simplemail) == "undefined" ) {technalxs.simplemail = {};};

technalxs.simplemail.SimpleMailWindowMessage = function(){
  var pub = {};

  pub.initializeMessage = function() {
    
    if (!technalxs.simplemail.SimpleMailUtils.isFirefox2()) technalxs.simplemail.SimpleMailDom.remove("grippy-style");
    initToolbarMode();
    
    // Important: Do not allow mail messages to execute javascript,
    // Because this javascript would be executed with chrome privileges

    technalxs.simplemail.SimpleMailDom.get("body").docShell.allowJavascript = false;

    technalxs.simplemail.SimpleMailDom.get("body").contentDocument.addEventListener("keypress", function(e) {
      if (!e.ctrlKey || String.fromCharCode(e.charCode) != 'a') {
        technalxs.simplemail.messageTreeView.onKeyPress(e);
      }
    }, false);

    technalxs.simplemail.SimpleMailOverlay = technalxs.simplemail.SimpleMailUtils.getBrowserWindow().technalxs.simplemail.SimpleMailOverlay;

    message = technalxs.simplemail.SimpleMailPrefs.getObject('message');
    messageTree = technalxs.simplemail.SimpleMailPrefs.getObject('messageTree');
    messageTree.view = technalxs.simplemail.messageTreeView;
    var browserWindow = technalxs.simplemail.SimpleMailUtils.getBrowserWindow();

    var body = technalxs.simplemail.SimpleMailDom.get("body");
    technalxs.simplemail.messageTreeView.displayHeaders(message);
    var html = message.partial
           ? technalxs.simplemail.SimpleMailBundle.getString("messageNotDownloaded")
           : message.id ? storage.getMessage(message.id).html : " ";

    var originalHTML = html;
    
    if (html !== " ") {
      var source = technalxs.simplemail.SimpleMailFile.getAttachmentsDirectory(message.attachmentsDir);
      source.append(technalxs.simplemail.SimpleMailFile.MESSAGE_SOURCE);
      source = technalxs.simplemail.SimpleMailFile.readFile(source);
    }
    
    if (technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnReceive") && html !== " ") {
      var partAttachs = technalxs.simplemail.messageTreeView.displayAttachments(html, message);
      
      var attachments = new Array();
      technalxs.simplemail.SimpleMailMessageEncoder.cidNames = [];
      technalxs.simplemail.SimpleMailMessageEncoder.ContentId = [];
      technalxs.simplemail.SimpleMailMessageEncoder.ContentDisposition = [];
      technalxs.simplemail.SimpleMailMessageEncoder.ContentType = [];
      var tmpMessage = technalxs.simplemail.SimpleMailMessageEncoder.parse(source, attachments, technalxs.simplemail.SimpleMailMessageEncoder.cidNames, technalxs.simplemail.SimpleMailMessageEncoder.ContentId, technalxs.simplemail.SimpleMailMessageEncoder.ContentDisposition, technalxs.simplemail.SimpleMailMessageEncoder.ContentType);
  
      if (!source.match(/name\=/gim) && !source.match(/filename\=/gim) && !source.match(/Content\-ID\:/gim) || partAttachs == null){  // No Attachments
        var html = technalxs.simplemail.SimpleMailUtils.parseHTML(document, tmpMessage.html, true);
        html = technalxs.simplemail.messageTreeView.plaintextMessage(html);
        html = html.replace(/(\r\n).*?/g,"<br>"); 
      } else {
        if (partAttachs != null) {
          partAttachs = partAttachs.join("");
        }      
        if (source.match(/text\/plain/gim)) { // Plaintext part in the message
          var html = tmpMessage.html + "<br>" + partAttachs;
          var html = technalxs.simplemail.SimpleMailUtils.parseHTML(document, html, true);
          html = technalxs.simplemail.messageTreeView.plaintextMessage(html);
        } else {
          // Remove Inline images
          var getImages = tmpMessage.html.toString().match(/<img[^>]*>(.*?)>*/gim); 
          if (getImages != null){
            for (var i in getImages){
              tmpMessage.html = tmpMessage.html.replace(getImages[i], "");
            }
          }
          var html = technalxs.simplemail.SimpleMailUtils.parseHTML(document, tmpMessage.html, true);
          html = technalxs.simplemail.messageTreeView.plaintextMessage(html);
          html = html.replace(/(\r\n).*?/g,"<br>");   
          html = html  + "<br>" + partAttachs;
        }
      }
  
      if (!(technalxs.simplemail.SimpleMailOverlay.storage.getMessage(message.id).html).match(/\<a\sclass\=\'attachment\'/gim)) {
        message.html = originalHTML;
        technalxs.simplemail.SimpleMailOverlay.storage.updateMessage(message);
      }
    } else {
     html = technalxs.simplemail.messageTreeView.displayAttachments(html, message);
    }
    
    html = technalxs.simplemail.SimpleMailText.imageToLink(html);
    
    // Change : remove : i don't remember what does this does !!
    /*if (html !== " " && source.toString().match(/Content\-Type\: text\/plain/gim) && technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnReceive")) {
      html = technalxs.simplemail.SimpleMailText.linkToLink(html);
    } */
    
    body.contentDocument.title = message.subject;
    
    if(technalxs.simplemail.SimpleMailPrefs.getBool("removeImages") || technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnReceive")){
      var getHtmlImages = html.toString().match(/<img[^>]*>(.*?)>*/gim);
      if (getHtmlImages != null){
        for (var k in getHtmlImages){ 
          if (getHtmlImages[k].match(/http/gim)){
            var html = html.replace(getHtmlImages[k], technalxs.simplemail.SimpleMailBundle.getString("removedimages"));
          }
        }
      }
      if (technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnReceive")){
        html = technalxs.simplemail.SimpleMailText.linkToText(html);
      }
    }
      
    var fragment = technalxs.simplemail.SimpleMailUtils.parseHTML(body.contentDocument, html, true);
    body.contentDocument.body.innerHTML = "";
    body.contentDocument.body.appendChild(fragment);
    
    if (message.returnReceiptTo &&
        message.uid && !message.partial)
    {
      technalxs.simplemail.messageTreeView.sendReturnReceipt(message);
    }
  
    clearTimeout(technalxs.simplemail.messageTreeView.markReadTimeout);
    
    if (!message.read && !message.partial) {
      technalxs.simplemail.messageTreeView.startMarkReadTimeout(message);
    }
  }
  return pub;
}();
      
function initToolbarMode() {
  var mode = technalxs.simplemail.SimpleMailPrefs.getString("toolbarMode");
  technalxs.simplemail.SimpleMailDom.get("simplemail-toolbar").setAttribute("mode", mode);

  var menuitems = technalxs.simplemail.SimpleMailDom.get("toolbar-menu").childNodes;
  for(var i = 0; i < menuitems.length; i++) {
    if (menuitems[i].value == mode) {
      menuitems[i].setAttribute("checked", true);
    }
  }
    if (technalxs.simplemail.SimpleMailPrefs.getBool("old")) {
      technalxs.simplemail.SimpleMailDom.remove("nuvola-style");
      technalxs.simplemail.SimpleMailDom.remove("oxygen-style");
      technalxs.simplemail.SimpleMailDom.remove("australis-style");
    }
    else if (technalxs.simplemail.SimpleMailPrefs.getBool("nuvola")) {
      technalxs.simplemail.SimpleMailDom.remove("old-style");
      technalxs.simplemail.SimpleMailDom.remove("oxygen-style");
      technalxs.simplemail.SimpleMailDom.remove("australis-style");
    }
    else if (technalxs.simplemail.SimpleMailPrefs.getBool("oxygen")) {
      technalxs.simplemail.SimpleMailDom.remove("old-style");
      technalxs.simplemail.SimpleMailDom.remove("nuvola-style");
      technalxs.simplemail.SimpleMailDom.remove("australis-style");
    }
    else if (technalxs.simplemail.SimpleMailPrefs.getBool("australis")) {
      technalxs.simplemail.SimpleMailDom.remove("old-style");
      technalxs.simplemail.SimpleMailDom.remove("nuvola-style");
      technalxs.simplemail.SimpleMailDom.remove("oxygen-style");
    }
}

function updateToolbarMode() {
  var menuitems = technalxs.simplemail.SimpleMailDom.get("toolbar-menu").childNodes;
  for(var i = 0; i < menuitems.length; i++) {
    if (menuitems[i].getAttribute("checked")) {
      technalxs.simplemail.SimpleMailPrefs.setString("toolbarMode", menuitems[i].value);
      technalxs.simplemail.SimpleMailDom.get("simplemail-toolbar").setAttribute("mode", menuitems[i].value);
    }
  }
}

function updateFavIcon() {
  var tab = technalxs.simplemail.SimpleMailUtils.getDocumentTab(document);
  var gBrowser = technalxs.simplemail.SimpleMailUtils.getBrowser();

  var status = technalxs.simplemail.SimpleMailOverlay.getStatus();
  var icon = technalxs.simplemail.SimpleMailFile.getStatusIconURL(status);
  gBrowser.setIcon(tab, icon);
}

function reply(all) {
  if (!technalxs.simplemail.SimpleMailPrefs.getBool("newMessagesInWindow")) {
    technalxs.simplemail.SimpleMailOverlay.refreshTab("chrome://simplemail/content/main/main.xul");
  }
  technalxs.simplemail.SimpleMailPrefs.setObject('message', message);
  setTimeout(function(){technalxs.simplemail.messageTreeView.openReply(all);}, 250); 
}

function forward() {
  if (!technalxs.simplemail.SimpleMailPrefs.getBool("newMessagesInWindow")) {
    technalxs.simplemail.SimpleMailOverlay.refreshTab("chrome://simplemail/content/main/main.xul");
  }
  technalxs.simplemail.SimpleMailPrefs.setObject('message', message);
  setTimeout(function(){technalxs.simplemail.messageTreeView.openForward();}, 250); 
}

function deleteThisMail(message) {
  if (message.folderId != technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH & technalxs.simplemail.SimpleMailPrefs.getBool("moveToTrash")) {
    message.folderId = technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH 
    
    // Manage SPAMs
    if (message.folderId == technalxs.simplemail.SimpleMailManageFolder.getFolderId("SPAM")) {
      message.spam = true;
      var messageFrom = message.from;
      processFilterSPAM(messageFrom);
    } else if (message.folderId !== technalxs.simplemail.SimpleMailManageFolder.getFolderId("SPAM") && message.spam == true) {
      message.spam = false;
      var messageFrom = message.from;
      deleteRuleFilterSPAM(messageFrom);
    }
    storage.saveMessageState(message);
  } else {
    var msgs = new Array();
    msgs.push(message);
    var confirmText = technalxs.simplemail.SimpleMailBundle.getString("deleteMessages");
    technalxs.simplemail.SimpleMailOverlay.askDeleteMail(msgs, confirmText, window);
  }
  var mainWindow = technalxs.simplemail.SimpleMailOverlay.getMainWindow(true);
  window.close();
  if (mainWindow) mainWindow.history.go();
}

function saveMessageAs() {
  technalxs.simplemail.SimpleMailPrefs.setObject('message', message);
  technalxs.simplemail.messageTreeView.saveMessageAs();
}      

function print() {
  technalxs.simplemail.SimpleMailPrefs.setObject('message', message);
  technalxs.simplemail.messageTreeView.printMessage();
}

function onClose() {
  technalxs.simplemail.SimpleMailPrefs.clear('message');
  technalxs.simplemail.SimpleMailPrefs.clear('messageTree');
  technalxs.simplemail.SimpleMailPrefs.clear('messageIndex');
  technalxs.simplemail.SimpleMailPrefs.clear('folderIndex');
}