var filter = window.arguments[0].filter;
var storage;

function initialize() {
  technalxs.simplemail.SimpleMailOverlay = technalxs.simplemail.SimpleMailUtils.getBrowserWindow().technalxs.simplemail.SimpleMailOverlay;
  storage = technalxs.simplemail.SimpleMailOverlay.storage;

  populateTypes();
  technalxs.simplemail.SimpleMailUtils.selectItem("type", filter.type);

  var name = filter.getName();
  document.title = filter.id ? technalxs.simplemail.SimpleMailBundle.getString("editFilter", [name])
                             : technalxs.simplemail.SimpleMailBundle.getString("newFilter");
  technalxs.simplemail.SimpleMailDom.get("name").value = name;

  initRules(filter.rules);
  initActions(filter.actions);
}

function onAccept() {
  filter.name = technalxs.simplemail.SimpleMailDom.get("name").value;
  filter.type = technalxs.simplemail.SimpleMailDom.get("type").selectedItem.value;
}

function onCancel() {
  window.arguments[0].filter = null;
}

function populateTypes() {
  var menupopup = technalxs.simplemail.SimpleMailDom.get("type").menupopup;
  var menuitem = document.createElement("menuitem");
  menuitem.setAttribute("label", technalxs.simplemail.SimpleMailBundle.getString("inbox"));
  menuitem.setAttribute("value", technalxs.simplemail.SimpleMailModel.SimpleMailFilter.INBOX);
  menupopup.appendChild(menuitem);
  var menuitem = document.createElement("menuitem");
  menuitem.setAttribute("label", technalxs.simplemail.SimpleMailBundle.getString("sent"));
  menuitem.setAttribute("value", technalxs.simplemail.SimpleMailModel.SimpleMailFilter.SENT);
  menupopup.appendChild(menuitem);
}