var folders = window.arguments[0].inn.folders;
var folderTree = window.arguments[0].inn.folderTree;
var folderTreeView = window.arguments[0].inn.folderTreeView;
var messageTreeView = window.arguments[0].inn.messageTreeView;
var storage;

var SimpleMailSPAM = {
  initialize: function() {
    technalxs.simplemail.SimpleMailOverlay = technalxs.simplemail.SimpleMailUtils.getBrowserWindow().technalxs.simplemail.SimpleMailOverlay;
    storage = technalxs.simplemail.SimpleMailOverlay.storage;

    technalxs.simplemail.SimpleMailPrefs.getBool("movespam") ? technalxs.simplemail.SimpleMailDom.get("styleSPAM").selectedIndex = 0
                                             : technalxs.simplemail.SimpleMailPrefs.getBool("trashspam") ? technalxs.simplemail.SimpleMailDom.get("styleSPAM").selectedIndex = 1
                                             : technalxs.simplemail.SimpleMailPrefs.getBool("deletespam") ? technalxs.simplemail.SimpleMailDom.get("styleSPAM").selectedIndex = 2
                                             : technalxs.simplemail.SimpleMailDom.get("styleSPAM").selectedIndex = 3;
                                             
    if (technalxs.simplemail.SimpleMailPrefs.getBool("movespam")){
      checkFolderSPAMPrefs();
     }
    if (technalxs.simplemail.SimpleMailPrefs.getBool("nospam")){
      technalxs.simplemail.SimpleMailDom.get('markspamasread').disabled = true;
    }
    technalxs.simplemail.SimpleMailDom.get("markspamasread").checked = technalxs.simplemail.SimpleMailPrefs.getBool("markspamasread");
  }
};

function checkFolderSPAMPrefs() {
  var folderSPAM = "SPAM";
  var spamFolderId = technalxs.simplemail.SimpleMailManageFolder.getFolderId(folderSPAM);

  if (typeof(spamFolderId) == 'undefined') {
    var spamFolder = "SPAM";
    var folderSPAM = new technalxs.simplemail.SimpleMailModel.SimpleMailFolder(null, null, spamFolder);
    folderTree.view = folderTreeView;
    technalxs.simplemail.SimpleMailManageFolder.setFolderParent(folderSPAM, 0);
    folders = storage.getFolders();
    folderTree = technalxs.simplemail.SimpleMailDom.get("folder-tree");
    technalxs.simplemail.SimpleMailManageFolder.updateFolderCounts();
    spamFolderId = folderSPAM.id;
    return  spamFolderId;
  }
}

function styleSPAM(selectedIndex) {
  if (technalxs.simplemail.SimpleMailDom.get("styleSPAM").selectedIndex == 0) {
    technalxs.simplemail.SimpleMailPrefs.setBool('movespam', true);
    technalxs.simplemail.SimpleMailPrefs.setBool('trashspam', false);
    technalxs.simplemail.SimpleMailPrefs.setBool('deletespam', false);
    technalxs.simplemail.SimpleMailPrefs.setBool('nospam', false);
    technalxs.simplemail.SimpleMailDom.get('markspamasread').disabled = false;
    checkFolderSPAMPrefs();
    checkChangeActions();
  }
  else if (technalxs.simplemail.SimpleMailDom.get("styleSPAM").selectedIndex == 1){
    technalxs.simplemail.SimpleMailPrefs.setBool('movespam', false);
    technalxs.simplemail.SimpleMailPrefs.setBool('trashspam', true);
    technalxs.simplemail.SimpleMailPrefs.setBool('deletespam', false);
    technalxs.simplemail.SimpleMailPrefs.setBool('nospam', false);
    technalxs.simplemail.SimpleMailDom.get('markspamasread').disabled = false;
    checkChangeActions();
  }
  else if (technalxs.simplemail.SimpleMailDom.get("styleSPAM").selectedIndex == 2){
    technalxs.simplemail.SimpleMailPrefs.setBool('movespam', false);
    technalxs.simplemail.SimpleMailPrefs.setBool('trashspam', false);
    technalxs.simplemail.SimpleMailPrefs.setBool('deletespam', true);
    technalxs.simplemail.SimpleMailPrefs.setBool('nospam', false);
    technalxs.simplemail.SimpleMailDom.get('markspamasread').disabled = false;
    checkChangeActions();
  }
  else if (technalxs.simplemail.SimpleMailDom.get("styleSPAM").selectedIndex == 3){
    technalxs.simplemail.SimpleMailPrefs.setBool('movespam', false);
    technalxs.simplemail.SimpleMailPrefs.setBool('trashspam', false);
    technalxs.simplemail.SimpleMailPrefs.setBool('deletespam', false);
    technalxs.simplemail.SimpleMailPrefs.setBool('nospam', true);
    technalxs.simplemail.SimpleMailPrefs.setBool('markspamasread', false);
    technalxs.simplemail.SimpleMailDom.get('markspamasread').disabled = true;
    checkChangeActions();
  }
}

function onCancel() {
  var mainWindow = technalxs.simplemail.SimpleMailOverlay.getMainWindow(true);
  window.close();
  if (mainWindow) mainWindow.history.go();
  technalxs.simplemail.SimpleMailOverlay.spamWindow.focus();
}