if(typeof(technalxs) == "undefined") {var technalxs = {};};
if(typeof(technalxs.simplemail) == "undefined" ) {technalxs.simplemail = {};};

technalxs.simplemail.SimpleMailAdresses = function(){
  var pub = {};

  pub.addressTree = null,
  pub.addresses= null,
  pub.group = [],
  pub.groupTree = [],
  
  
  pub.initialize = function() {
    technalxs.simplemail.SimpleMailOverlay = technalxs.simplemail.SimpleMailUtils.getBrowserWindow().technalxs.simplemail.SimpleMailOverlay;
  
    document.title = address.id ? technalxs.simplemail.SimpleMailBundle.getString("editAddress", [address])
                                : technalxs.simplemail.SimpleMailBundle.getString("newAddress");
    technalxs.simplemail.SimpleMailDom.get("name").value = address.name;
    technalxs.simplemail.SimpleMailDom.get("name").focus();
    technalxs.simplemail.SimpleMailDom.get("email").value = address.email;
    technalxs.simplemail.SimpleMailDom.get("postaladdress").value = address.postaladdress;
    technalxs.simplemail.SimpleMailDom.get("phone").value = address.phone;
    
    technalxs.simplemail.SimpleMailDom.get("type").value = address.group ? "group" : "email";
  
    technalxs.simplemail.SimpleMailAdresses.groupTree = technalxs.simplemail.SimpleMailDom.get("group-tree");
    technalxs.simplemail.SimpleMailAdresses.groupTree.view = technalxs.simplemail.groupTreeView;
    technalxs.simplemail.SimpleMailAdresses.setGroupIds(address.group);
  
    technalxs.simplemail.SimpleMailAdresses.initAddresses();
    technalxs.simplemail.addressTreeView.action = technalxs.simplemail.SimpleMailAdresses.addToGroup;
    technalxs.simplemail.addressTreeView.delete = function() {}
  },
  
  pub.onAccept = function() {
		//userok210 
		if (!technalxs.simplemail.SimpleMailAdresses.checkValues(technalxs.simplemail.SimpleMailDom.get("email")))
			return false;

    var name = technalxs.simplemail.SimpleMailDom.get("name").value;
    var email = technalxs.simplemail.SimpleMailDom.get("email").value;
    
    //userok210 var evt = document.createEvent("MouseEvents");
    //userok210 evt.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
    //userok210 var cb = document.documentElement.getButton("accept");
    //userok210 cb.addEventListener("click", technalxs.simplemail.SimpleMailAdresses.checkValues(technalxs.simplemail.SimpleMailDom.get("email"), evt), false);
    var postaladdress = technalxs.simplemail.SimpleMailDom.get("postaladdress").value;
    var phone = technalxs.simplemail.SimpleMailDom.get("phone").value;
    if (phone == "undefined") phone = "";
    var isGroup = technalxs.simplemail.SimpleMailDom.get("type").value == "group";

    address.name = name;
    address.postaladdress = postaladdress;
    address.phone = phone;
    address.group = isGroup ? technalxs.simplemail.SimpleMailAdresses.getGroupIds(technalxs.simplemail.SimpleMailAdresses.group) : "";
    address.email = !isGroup ? email : "";
		//userok210
		return true;
  },
  
  //userok210 pub.checkValues = function(txtBox, event) {
  pub.checkValues = function(txtBox) {
    var isGroup = technalxs.simplemail.SimpleMailDom.get("type").value == "group";

    if (isGroup && !technalxs.simplemail.SimpleMailDom.get("name").value) {
      var confirmText = technalxs.simplemail.SimpleMailBundle.getString("specifyGroupName");
      technalxs.simplemail.SimpleMailUtils.alert(confirmText);
      //userok210 document.documentElement.getButton("accept").addEventListener("click", event.preventDefault(), false);
      return false;
    }

		//userok210
    if (isGroup) 
			return true;
    
    if (!technalxs.simplemail.SimpleMailDom.get("email").value) {
      var confirmText = technalxs.simplemail.SimpleMailBundle.getString("specifyEmail");
      technalxs.simplemail.SimpleMailUtils.alert(confirmText);
      return false;
    }

    technalxs.simplemail.SimpleMailAdresses.addresses = technalxs.simplemail.SimpleMailOverlay.storage.getAddresses();
    document.getElementById('email').value = txtBox.value;
    // Check if address already exist
    for(var i in technalxs.simplemail.SimpleMailAdresses.addresses) {
      addrmail = address.email ? address.email.toLowerCase() : null; //userok210
			if (technalxs.simplemail.SimpleMailAdresses.addresses[i].email.toLowerCase() == txtBox.value.toLowerCase() && txtBox.value.toLowerCase() !== addrmail) {//userok210
        //console.error("addrbook", technalxs.simplemail.SimpleMailAdresses.addresses[i].email.toLowerCase(), txtBox.value.toLowerCase(), address.email);//userok210
				var confirmText = technalxs.simplemail.SimpleMailBundle.getString("accountAlert");
        technalxs.simplemail.SimpleMailUtils.alert(confirmText);
        setTimeout (function () {
          document.getElementById('email').focus();
        }, 0);
        txtBox.value = address.email;
        //userok210 document.documentElement.getButton("accept").addEventListener("click", event.preventDefault(), false);
        return false;
      }
    }

    // Check if address is valid
    if (!txtBox.value.toLowerCase().match(/^[a-z0-9._%+-]+@(?:[a-z0-9-])/gim)) {
      var confirmText = technalxs.simplemail.SimpleMailBundle.getString("addressAlert");
      technalxs.simplemail.SimpleMailUtils.alert(confirmText);
      setTimeout (function () {
        document.getElementById('email').focus();
      }, 0);
      txtBox.value = address.email;
      //userok210 document.documentElement.getButton("accept").addEventListener("click", event.preventDefault(), false);
      return false;
    }

	//userok210
	return true;
  },
  
  pub.onCancel = function() {
    window.arguments[0].address = null;
  },
  
  pub.getGroupIds = function(items) {
    var ids = "";
    for(var i = 0; i < items.length; i++) {
      if (ids) ids += ",";
      ids += items[i].id;
    }
    return ids;
  },
  
  pub.setGroupIds = function(ids) {
    var oldCount = technalxs.simplemail.SimpleMailAdresses.group.length;
    technalxs.simplemail.SimpleMailAdresses.group = ids ? technalxs.simplemail.SimpleMailOverlay.storage.getAddresses(ids) : [];
    technalxs.simplemail.groupTreeView.treebox.rowCountChanged(0, technalxs.simplemail.SimpleMailAdresses.group.length - oldCount);
    technalxs.simplemail.groupTreeView.treebox.invalidate();
  },
  
  pub.addToGroup = function() {
    technalxs.simplemail.SimpleMailDom.get("type").value = "group";
  
    var items = new Array();
    technalxs.simplemail.addressTreeView.forEachSelected(function(index) {
      items.push(technalxs.simplemail.SimpleMailAdresses.addresses[index]);
    });
    items = technalxs.simplemail.SimpleMailAdresses.group.concat(items);
    technalxs.simplemail.SimpleMailAdresses.setGroupIds(technalxs.simplemail.SimpleMailAdresses.getGroupIds(items));
  },
  
  pub.deleteFromGroup = function() {
    technalxs.simplemail.groupTreeView.forEachSelected(function(index) {
      technalxs.simplemail.SimpleMailAdresses.group.splice(index, 1);
      technalxs.simplemail.groupTreeView.treebox.rowCountChanged(index, -1);
    });
  },
        
  pub.initAddresses = function() {
    technalxs.simplemail.SimpleMailAdresses.addresses = technalxs.simplemail.SimpleMailOverlay.storage.getAddresses();
    technalxs.simplemail.SimpleMailAdresses.addressTree = technalxs.simplemail.SimpleMailDom.get("address-tree");
    technalxs.simplemail.SimpleMailAdresses.addressTree.view = technalxs.simplemail.addressTreeView;
    if (technalxs.simplemail.SimpleMailAdresses.addressTree.view.rowCount > 0) technalxs.simplemail.SimpleMailAdresses.addressTree.view.selection.select(0);
    technalxs.simplemail.SimpleMailAdresses.updateAddressTree()
  },
  
  pub.editAddress = function(add) {
    var address = add ? technalxs.simplemail.SimpleMailModel.SimpleMailAddress.create() : technalxs.simplemail.SimpleMailAdresses.addresses[technalxs.simplemail.SimpleMailAdresses.addressTree.currentIndex];
    var param = { address: address };
  
    openDialog("chrome://simplemail/content/main/address.xul",
               "simplemail-preferences-address-window",
               "chrome,centerscreen,modal,resizable", param);
    if (param.address) {
      technalxs.simplemail.SimpleMailOverlay.storage.saveAddress(address);
      technalxs.simplemail.SimpleMailAdresses.updateAddressTree();
  
      for(var i = 0; i < technalxs.simplemail.SimpleMailAdresses.addresses.length; i++) {
        if (technalxs.simplemail.SimpleMailAdresses.addresses[i].id == address.id) {
          technalxs.simplemail.SimpleMailAdresses.addressTree.view.selection.select(i);
        }
      }
    }
  },
  
  pub.deleteAddress = function() {
    if (technalxs.simplemail.SimpleMailUtils.confirm(technalxs.simplemail.SimpleMailBundle.getString("deleteAddresses"))) {
      technalxs.simplemail.addressTreeView.forEachSelected(function(index) {
        technalxs.simplemail.SimpleMailOverlay.storage.deleteAddress(technalxs.simplemail.SimpleMailAdresses.addresses[index]);
      });
      technalxs.simplemail.SimpleMailAdresses.updateAddressTree();
      technalxs.simplemail.SimpleMailAdresses.addressTree.view.selection.clearSelection();
    }
  },
  
  pub.onSelectAddress = function() {
    var count = !technalxs.simplemail.SimpleMailAdresses.addressTree.view.selection.getRangeCount();
    var edit = technalxs.simplemail.SimpleMailDom.get("address-edit"), deletee = technalxs.simplemail.SimpleMailDom.get("address-delete");
    if (edit.nodeName == "button") edit.disabled = deletee.disabled = count;
    else edit.hidden = deletee.hidden = count;
  },
  
  pub.updateAddressTree = function() {
    var oldCount = technalxs.simplemail.SimpleMailAdresses.addresses.length;
    technalxs.simplemail.SimpleMailAdresses.addresses = technalxs.simplemail.SimpleMailOverlay.storage.getAddresses(null, technalxs.simplemail.SimpleMailAdresses.getSort());
    technalxs.simplemail.addressTreeView.treebox.rowCountChanged(0, technalxs.simplemail.SimpleMailAdresses.addresses.length - oldCount);
    technalxs.simplemail.addressTreeView.treebox.invalidate();
  },
  
  pub.getSort = function() {
    var column = technalxs.simplemail.addressTreeView.getSortedColumn();
    if (!column) return;
  
    var direction = column.getAttribute("sortDirection");
    if (direction) {
      var sortColumns = {
        "address-name": "name",
        "address-email" : "email",
        "address-favorite" : "favorite",
        "address-postaladdress" : "addressp",
        "address-phone" : "phonep"
      };
      var id = sortColumns[column.id] || column.id;
      return id + " " + (direction == "descending" ? "DESC" : "ASC");
    }
  }
  return pub;
}();



technalxs.simplemail.groupTreeView = function (){
  var pub = {  
    get rowCount() {
      return technalxs.simplemail.SimpleMailAdresses.group.length;
    }
  };

  pub.getCellText = function(row, column) {
    var name = column.id.replace(/group-/, "");
    return technalxs.simplemail.SimpleMailAdresses.group[row][name];
  },
  
  pub.action = technalxs.simplemail.SimpleMailAdresses.deleteFromGroup,
  pub.delete = technalxs.simplemail.SimpleMailAdresses.deleteFromGroup

  return pub;
}();
technalxs.simplemail.DefaultTreeView.extend(technalxs.simplemail.groupTreeView);



technalxs.simplemail.addressTreeView = function (){
  var pub = { 
    get rowCount() {
      return technalxs.simplemail.SimpleMailAdresses.addresses.length;
    }
  };

  pub.getCellText = function(row, column) {
    var name = column.id.replace(/address-/, "");
    return technalxs.simplemail.SimpleMailAdresses.addresses[row][name];
  },
  
  pub.getCellProperties = function(row, column, props) {
    var address = technalxs.simplemail.SimpleMailAdresses.addresses[row];
    if (address.group) {
      if (props) {
        var atom = technalxs.simplemail.addressTreeView.atomService.getAtom("group");
        props.AppendElement(atom);
      } else return "group";
    }
  },
  
  pub.isEditable = function(row, column) {
    return column.id == "address-favorite";
  },
  
  pub.getCellValue = function(row, column) {
    return technalxs.simplemail.SimpleMailAdresses.addresses[row].favorite ? "true" : "false";
  },
  
  pub.setCellValue = function(row, column, value) {
    technalxs.simplemail.SimpleMailAdresses.addresses[row].favorite = value == "true";
    technalxs.simplemail.SimpleMailOverlay.storage.saveAddress(technalxs.simplemail.SimpleMailAdresses.addresses[row]);
    technalxs.simplemail.addressTreeView.cycleCell(row, column);
  },
  
  pub.action = function() {
    if (technalxs.simplemail.SimpleMailAdresses.addressTree.currentIndex != -1) {
      var address = technalxs.simplemail.SimpleMailAdresses.addresses[technalxs.simplemail.SimpleMailAdresses.addressTree.currentIndex];
      technalxs.simplemail.messageTreeView.openNew(address.toString());
    }
  },
  
  pub.cycleHeader = function(column) {
    column = technalxs.simplemail.SimpleMailDom.get(column.id);
    var sortedColumn = technalxs.simplemail.addressTreeView.getSortedColumn();
    if (sortedColumn && sortedColumn != column) {
      sortedColumn.removeAttribute("sortDirection");
    }            
    var direction = column.getAttribute("sortDirection");
    column.setAttribute("sortDirection",
                        technalxs.simplemail.addressTreeView.nextDirection[direction]);
    
    technalxs.simplemail.SimpleMailAdresses.updateAddressTree();
  },
  
  pub.delete = technalxs.simplemail.SimpleMailAdresses.deleteAddress
  
  return pub;
}();
technalxs.simplemail.DefaultTreeView.extend(technalxs.simplemail.addressTreeView);