if(typeof(technalxs) == "undefined") {var technalxs = {};};
if(typeof(technalxs.simplemail) == "undefined" ) {technalxs.simplemail = {};};

technalxs.simplemail.SimpleMailMain = function(){
  var pub = {};

  pub.initialize = function() {
    if (initialized) return;
    initialized = true;
    
    if (!technalxs.simplemail.SimpleMailUtils.isFirefox2()) technalxs.simplemail.SimpleMailDom.remove("grippy-style");
    technalxs.simplemail.SimpleMailMain.initToolbarMode();
    
    // Important: Do not allow mail messages to execute javascript,
    // Because this javascript would be executed with chrome privileges
    
    technalxs.simplemail.SimpleMailDom.get("body").docShell.allowJavascript = false;
    technalxs.simplemail.SimpleMailDom.get("printer").docShell.allowJavascript = false;
    
    technalxs.simplemail.SimpleMailDom.get("body").contentDocument.addEventListener("keypress", function(e) {
      if (!e.ctrlKey || String.fromCharCode(e.charCode) != 'a') {
        technalxs.simplemail.messageTreeView.onKeyPress(e);
      }
    }, false);
    
    technalxs.simplemail.SimpleMailOverlay = technalxs.simplemail.SimpleMailUtils.getBrowserWindow().technalxs.simplemail.SimpleMailOverlay;
    
    updateFavIcon();
    
    messages = new Array();
    messageTree = technalxs.simplemail.SimpleMailDom.get("message-tree");
    messageTree.view = technalxs.simplemail.messageTreeView;
    
    folders = technalxs.simplemail.SimpleMailOverlay.storage.getFolders();
    folderTree = technalxs.simplemail.SimpleMailDom.get("folder-tree");
    folderTree.view = technalxs.simplemail.folderTreeView;
    technalxs.simplemail.SimpleMailAdresses.initAddresses();
    
    if (technalxs.simplemail.SimpleMailPrefs.getBool("nospam")){
      technalxs.simplemail.SimpleMailDom.get("asspam").hidden = true;
      technalxs.simplemail.SimpleMailDom.get("spam").hidden = true;
    }
    else {
      technalxs.simplemail.SimpleMailDom.get("spam").hidden = false;
    } 
     
    technalxs.simplemail.SimpleMailManageFolder.displayInbox();
    
    var browserWindow = technalxs.simplemail.SimpleMailUtils.getBrowserWindow();

    var tabContainer = browserWindow.getBrowser().selectedTab;
    tabContainer.addEventListener("TabClose", technalxs.simplemail.SimpleMailMain.onTabClose, false);
    
    /*var stat = technalxs.simplemail.SimpleMailOverlay.getStatus();
    if (stat == "loading") {
      var counter = 10;
      technalxs.simplemail.SimpleMailMain.showProgress(counter);
    }*/
  },

  pub.showProgress = function(counter) {
    var stat = technalxs.simplemail.SimpleMailOverlay.getStatus();
    if (stat == "loading") {
      counter = counter+5;
      if (counter == 105) {
        counter = 0;
      }
      var win = technalxs.simplemail.SimpleMailOverlay.getMainWindow();
      win.document.getElementById("progressMeter").collapsed=false; 
      win.document.getElementById("cancelcheck").hidden=false;
      win.document.getElementById("progressMeterText").hidden=false;
      win.document.getElementById("progressMeter").value = counter;
      technalxs.simplemail.SimpleMailOverlay.updateIcons();
      setTimeout(function(){technalxs.simplemail.SimpleMailMain.showProgress(counter);}, 100);
    }
  },

  pub.switchLayout = function() {
    var orient = technalxs.simplemail.SimpleMailDom.get("right-column").orient == "horizontal" ? "vertical" : "horizontal";
    technalxs.simplemail.SimpleMailDom.get("right-column").orient = orient;
    technalxs.simplemail.SimpleMailDom.get("right-splitter").orient = orient;
  },

  pub.switchHeaders = function() {
    technalxs.simplemail.SimpleMailDom.get("headers").collapsed = !technalxs.simplemail.SimpleMailDom.get("headers").collapsed;
  },
      
  pub.initToolbarMode = function() {
    var mode = technalxs.simplemail.SimpleMailPrefs.getString("toolbarMode");
    technalxs.simplemail.SimpleMailDom.get("simplemail-toolbar").setAttribute("mode", mode);

    var menuitems = technalxs.simplemail.SimpleMailDom.get("toolbar-menu").childNodes;
    for(var i = 0; i < menuitems.length; i++) {
      if (menuitems[i].value == mode) {
        menuitems[i].setAttribute("checked", true);
      }
    }
    if (technalxs.simplemail.SimpleMailPrefs.getBool("old")) {
      technalxs.simplemail.SimpleMailDom.remove("nuvola-style");
      technalxs.simplemail.SimpleMailDom.remove("oxygen-style");
      technalxs.simplemail.SimpleMailDom.remove("australis-style");
    }
    else if (technalxs.simplemail.SimpleMailPrefs.getBool("nuvola")) {
      technalxs.simplemail.SimpleMailDom.remove("old-style");
      technalxs.simplemail.SimpleMailDom.remove("oxygen-style");
      technalxs.simplemail.SimpleMailDom.remove("australis-style");
    }
    else if (technalxs.simplemail.SimpleMailPrefs.getBool("oxygen")) {
      technalxs.simplemail.SimpleMailDom.remove("old-style");
      technalxs.simplemail.SimpleMailDom.remove("nuvola-style");
      technalxs.simplemail.SimpleMailDom.remove("australis-style");
    }
    else if (technalxs.simplemail.SimpleMailPrefs.getBool("australis")) {
      technalxs.simplemail.SimpleMailDom.remove("old-style");
      technalxs.simplemail.SimpleMailDom.remove("nuvola-style");
      technalxs.simplemail.SimpleMailDom.remove("oxygen-style");
    }
  },

  pub.updateToolbarMode = function() {
    var menuitems = technalxs.simplemail.SimpleMailDom.get("toolbar-menu").childNodes;
    for(var i = 0; i < menuitems.length; i++) {
      if (menuitems[i].getAttribute("checked")) {
        technalxs.simplemail.SimpleMailPrefs.setString("toolbarMode", menuitems[i].value);
        technalxs.simplemail.SimpleMailDom.get("simplemail-toolbar").setAttribute("mode", menuitems[i].value);
      }
    }
  },
  
  pub.archiveFolder = function(){
    var param = {inn:{folder: technalxs.simplemail.SimpleMailManageFolder.getCurrentFolder(), folders: technalxs.simplemail.SimpleMailOverlay.storage.getFolders(), folderTree: technalxs.simplemail.SimpleMailDom.get("folder-tree")}, out: null};
    openDialog("chrome://simplemail/content/archive.xul",
               "simplemail-archive-window",
               "chrome,modal,centerscreen,resizable", param);

    if (param.out) {
      folders = technalxs.simplemail.SimpleMailOverlay.storage.getFolders();
      folderTree = technalxs.simplemail.SimpleMailDom.get("folder-tree");
      folderTree.view = technalxs.simplemail.folderTreeView;
      technalxs.simplemail.SimpleMailManageFolder.updateFolderCounts();
      technalxs.simplemail.SimpleMailManageFolder.displayInbox();
      technalxs.simplemail.messageTreeView.displayFolder();
    }
  },
  
  pub.openSPAMOptions = function() {
    if (!technalxs.simplemail.SimpleMailOverlay.spamWindow || technalxs.simplemail.SimpleMailOverlay.spamWindow.closed) {
    var param = {inn:{folder: technalxs.simplemail.SimpleMailManageFolder.getCurrentFolder(), folders: technalxs.simplemail.SimpleMailOverlay.storage.getFolders(), folderTree: technalxs.simplemail.SimpleMailDom.get("folder-tree"), folderTreeView: technalxs.simplemail.folderTreeView, messageTreeView: technalxs.simplemail.messageTreeView}, out: null};
        
      technalxs.simplemail.SimpleMailOverlay.spamWindow = openDialog("chrome://simplemail/content/preferences/spamprefs.xul",
                                          "simplemail-spam-window",
                                          "chrome,modal,centerscreen,resizable", param);
    } else technalxs.simplemail.SimpleMailOverlay.spamWindow.focus();
  },
  
  pub.onTabClose = function(event){
    if (event.target.linkedBrowser.contentDocument == document) technalxs.simplemail.SimpleMailMain.onClose();
  },
  
  pub.onUnload = function(){
    var browserWindow = technalxs.simplemail.SimpleMailUtils.getBrowserWindow();
    if (browserWindow !== null) {
      var tabContainer = browserWindow.getBrowser().selectedTab;
      tabContainer.removeEventListener("TabClose", technalxs.simplemail.SimpleMailMain.onTabClose, false);
    }
  },
  
  pub.onClose = function(){
    if (technalxs.simplemail.SimpleMailPrefs.getBool("cleanonexit")) technalxs.simplemail.SimpleMailMain.emptyOnExit();
    if (technalxs.simplemail.SimpleMailOverlay.openedWindows.length > 0) {
      for (var i = 0; i < technalxs.simplemail.SimpleMailOverlay.openedWindows.length; i++) {
        technalxs.simplemail.SimpleMailOverlay.openedWindows[i].close();
      }
    }
    if (technalxs.simplemail.SimpleMailPrefs.getBool("cleandatabase")) technalxs.simplemail.SimpleMailOverlay.storage.cleanDataBase();
  },  
  
  pub.emptyOnExit = function(){
    if (!technalxs.simplemail.SimpleMailManageFolder.isTrashEmpty()) {
      var folders = technalxs.simplemail.SimpleMailOverlay.storage.getFolders();
      for(var i in folders) {
        var children = folders[i];
        for (var j in children) {
          if (children[j].id == technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH){
            var folderTrash = children[j];
          }
        }
      }
     var confirmText = technalxs.simplemail.SimpleMailBundle.getString("emptyTrash");
     technalxs.simplemail.SimpleMailManageFolder.askDeleteFolder(folderTrash, confirmText, true, true);
    }
  }
  return pub;
}();               