function toggletoSpam() {
  var spam = false;

  if (technalxs.simplemail.SimpleMailPrefs.getBool("nospam")){
    return;
  }

  if (technalxs.simplemail.SimpleMailPrefs.getBool("movespam")) {
    checkfolderSPAM();
  }

  technalxs.simplemail.messageTreeView.forEachMessagesSelected(function(index) {
    spam |= !technalxs.simplemail.messageTreeView.messages[index].spam;
  });

  technalxs.simplemail.messageTreeView.forEachMessagesSelected(function(index) {
    if (technalxs.simplemail.messageTreeView.messages[index].spam  == 1) {
      var deleted = new Array();
      var message = technalxs.simplemail.messageTreeView.messages[index];
      technalxs.simplemail.messageTreeView.messages[index].folderId = technalxs.simplemail.SimpleMailModel.SimpleMailFolder.INBOX;
      if (technalxs.simplemail.messageTreeView.messages[index].read == 1) {
        var message = technalxs.simplemail.messageTreeView.messages[index];
        message.read = false;
      }
      message.spam = false;
      technalxs.simplemail.SimpleMailOverlay.storage.saveMessageState(message);
      deleted.push(technalxs.simplemail.messageTreeView.messages[index]);
      technalxs.simplemail.messageTreeView.onMessagesDeleted(deleted);
      folders = technalxs.simplemail.SimpleMailOverlay.storage.getFolders();
      folderTree = technalxs.simplemail.SimpleMailDom.get("folder-tree");
      folderTree.view = technalxs.simplemail.folderTreeView;
      technalxs.simplemail.SimpleMailManageFolder.updateFolderCounts();
      technalxs.simplemail.SimpleMailOverlay.updateIcons();
      var messageFrom = message.from;
      deleteRuleFilterSPAM(messageFrom);
    }
    else if (technalxs.simplemail.messageTreeView.messages[index].spam  == 0) {
      var message = technalxs.simplemail.messageTreeView.messages[index];
      var messageFrom = message.from;
      markSpam(index, spam);
      processFilterSPAM(messageFrom);
    } 
  });
}

// Mark spam message
function markSpam(index, spam) {
// Mark read
  if (technalxs.simplemail.SimpleMailPrefs.getBool("markspamasread")) {
    technalxs.simplemail.messageTreeView.forEachMessagesSelected(function(index) {
      if (technalxs.simplemail.messageTreeView.messages[index].read == 0) {
        var message = technalxs.simplemail.messageTreeView.messages[index];
        message.read = true;
      }
    })  
  }

// Manage spam
  if (technalxs.simplemail.SimpleMailPrefs.getBool("movespam") && technalxs.simplemail.SimpleMailManageFolder.getCurrentFolder().id != spamFolderId) {
    var deleted = new Array();
    technalxs.simplemail.messageTreeView.messages[index].folderId = spamFolderId;
    technalxs.simplemail.messageTreeView.messages[index].spam = true;  
    technalxs.simplemail.SimpleMailOverlay.storage.saveMessageState(technalxs.simplemail.messageTreeView.messages[index]);
    deleted.push(technalxs.simplemail.messageTreeView.messages[index]);
    technalxs.simplemail.messageTreeView.onMessagesDeleted(deleted);
  }
  else if (technalxs.simplemail.SimpleMailPrefs.getBool("trashspam") && technalxs.simplemail.SimpleMailManageFolder.getCurrentFolder().id != technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH) {
    var deleted = new Array();
    technalxs.simplemail.messageTreeView.messages[index].folderId = technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH;
    technalxs.simplemail.messageTreeView.messages[index].spam = true;
    technalxs.simplemail.SimpleMailOverlay.storage.saveMessageState(technalxs.simplemail.messageTreeView.messages[index]);
    deleted.push(technalxs.simplemail.messageTreeView.messages[index]);
    technalxs.simplemail.messageTreeView.onMessagesDeleted(deleted);
  }
  else if (technalxs.simplemail.SimpleMailPrefs.getBool("deletespam") && technalxs.simplemail.SimpleMailManageFolder.getCurrentFolder().id != technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH) {
    technalxs.simplemail.messageTreeView.deleteMail(true);
  }

  folders = technalxs.simplemail.SimpleMailOverlay.storage.getFolders();
  folderTree = technalxs.simplemail.SimpleMailDom.get("folder-tree");
  folderTree.view = technalxs.simplemail.folderTreeView;
  technalxs.simplemail.SimpleMailManageFolder.updateFolderCounts();
  technalxs.simplemail.SimpleMailOverlay.updateIcons();
}

function processFilterSPAM(messageFrom) {

  checkFilterSPAM();
    if (typeof(nameFilterSPAMId) == 'undefined') {
      addFilterSPAM();
      checkFilterSPAM();
      addActionFilterSPAM();
      checkChangeActions();
    }
    // Check change of action
    else {
      checkChangeActions();
    }
  addRuleFilterSPAM(messageFrom);
}

function checkChangeActions() {
  if (technalxs.simplemail.SimpleMailPrefs.getBool("nospam")){
    deleteActionFilterSPAM();
  }
  else {
    checkFilterSPAM();
    var filters = technalxs.simplemail.SimpleMailOverlay.storage.getFilters();
    for(var i in filters) {
      if (filters[i].id == nameFilterSPAMId) {
        filterSPAM = filters[i];
      }
    }

    initActions(filterSPAM.actions);
    if (actions == "") {
      addActionFilterSPAM();
    }

    for (var i in filterSPAM.actions){
      if (technalxs.simplemail.SimpleMailPrefs.getBool("trashspam") && filterSPAM.actions[i].param != technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH){
        deleteActionFilterSPAM();
        addActionFilterSPAM();
      }
      if (technalxs.simplemail.SimpleMailPrefs.getBool("deletespam") && filterSPAM.actions[i].param != "delete"){
        deleteActionFilterSPAM();
        addActionFilterSPAM();
      }
      if (technalxs.simplemail.SimpleMailPrefs.getBool("movespam")){
        checkfolderSPAM();
        if (filterSPAM.actions[i].param != spamFolderId){
          deleteActionFilterSPAM();
          addActionFilterSPAM();
        }
      }
    }
  } 
}

// Check if SPAM folder exist and get ID
function checkfolderSPAM() {
  spamFolderId = getSPAMFolderId("SPAM");

  if (typeof(spamFolderId) == 'undefined' && technalxs.simplemail.SimpleMailPrefs.getBool("movespam")) {
    addFolderSPAM();
  }
  return  spamFolderId;
}

function getSPAMFolderId(folderSPAM) {
  var spamFolderId = technalxs.simplemail.SimpleMailManageFolder.getFolderId(folderSPAM);
  return spamFolderId;
}

// Create Folder SPAM
function addFolderSPAM() {
  var spamFolder = "SPAM";
  var folderSPAM = new technalxs.simplemail.SimpleMailModel.SimpleMailFolder(null, null, spamFolder);
  folderTree.view = technalxs.simplemail.folderTreeView; 
  technalxs.simplemail.SimpleMailManageFolder.setFolderParent(folderSPAM, 0);
  folders = technalxs.simplemail.SimpleMailOverlay.storage.getFolders();
  folderTree = technalxs.simplemail.SimpleMailDom.get("folder-tree");
  folderTree.view = technalxs.simplemail.folderTreeView;
  technalxs.simplemail.SimpleMailManageFolder.updateFolderCounts();
  spamFolderId = folderSPAM.id;
  return  spamFolderId;
}

// Check if SPAMfilter exist and get ID
function checkFilterSPAM () {
  var nameFilterSPAM = "SPAM";
  getSPAMFilterId(nameFilterSPAM);

  if (typeof(nameFilterSPAMId) == 'undefined') {
    addFilterSPAM();
  }

  nameFilterSPAMId=getSPAMFilterId(nameFilterSPAM);
  return nameFilterSPAMId;
}

function getSPAMFilterId (nameFilterSPAM) {
  var filters = technalxs.simplemail.SimpleMailOverlay.storage.getFilters();
  for(var i in filters) {
    if (filters[i].name == nameFilterSPAM) {
      nameFilterSPAMId = filters[i].id;
      return nameFilterSPAMId;
    }
  }
}

// Create Filter
function addFilterSPAM() {
  filterSPAM = new technalxs.simplemail.SimpleMailModel.SimpleMailFilter(null, null, "SPAM", 1, new Array(), new Array());
  technalxs.simplemail.SimpleMailOverlay.storage.saveFilter(filterSPAM);
  return filterSPAM;
}

function initRules(aRules, aType) {
  rules = aRules;
  ruleType = aType;
}

function initActions(aActions) {
  actions = aActions;
}

function addRuleFilterSPAM (messageFrom) {
  // Get filter Object
  var filters = technalxs.simplemail.SimpleMailOverlay.storage.getFilters();
  for(var i in filters) {
    if (filters[i].id == nameFilterSPAMId) {
      filterSPAM = filters[i];
    }
  }

  initRules(filterSPAM.rules);

  // Check if rule exist
    for (var i in filterSPAM.rules){
      if (filterSPAM.rules[i].param == messageFrom){
      return;
      }
    }
    var ruleParam =  messageFrom;
    var rule = new technalxs.simplemail.SimpleMailModel.SimpleMailRule(null, nameFilterSPAMId, "from", 0, "contains", ruleParam);
    rules.push(rule);
    technalxs.simplemail.SimpleMailOverlay.storage.saveFilter(filterSPAM);
}

function addActionFilterSPAM () {
  var filters = technalxs.simplemail.SimpleMailOverlay.storage.getFilters();
  for(var i in filters) {
    if (filters[i].id == nameFilterSPAMId) {
    filterSPAM = filters[i];
    }
  }

  initActions(filterSPAM.actions);

  if (technalxs.simplemail.SimpleMailPrefs.getBool("movespam")){
    spamFolderId = getSPAMFolderId("SPAM");
    actionName = "folder";
    actionParam = "text: "+spamFolderId;
  }
  else if (technalxs.simplemail.SimpleMailPrefs.getBool("trashspam")){
    actionName = "folder";
    actionParam = "text: "+technalxs.simplemail.SimpleMailModel.SimpleMailFolder.TRASH;
  }
  else if (technalxs.simplemail.SimpleMailPrefs.getBool("deletespam")){
    actionName = "delete";
    actionParam = "";
  }
  var action = new technalxs.simplemail.SimpleMailModel.SimpleMailAction(null, nameFilterSPAMId, actionName, actionParam);
  actions.push(action);
  technalxs.simplemail.SimpleMailOverlay.storage.saveFilter(filterSPAM);
}

function deleteRuleFilterSPAM(messageFrom) {
  checkFilterSPAM();
  var filters = technalxs.simplemail.SimpleMailOverlay.storage.getFilters();
  for(var i in filters) {
    if (filters[i].id == nameFilterSPAMId) {
      filterSPAM = filters[i];
    }
  }

  initRules(filterSPAM.rules);

  var file = technalxs.simplemail.SimpleMailFile.getDataDirectory();
  file.append("simplemail.sqlite");
    // Check if rule exist
    for (var i in filterSPAM.rules){
      if (filterSPAM.rules[i].param == messageFrom){
        var storageService = Components.classes["@mozilla.org/storage/service;1"]
                      .getService(Components.interfaces.mozIStorageService);
        var connection = storageService.openDatabase(file);
        var statement = connection.createStatement("DELETE FROM rules WHERE filterId=?1 AND id=?2");
        statement.bindInt32Parameter(0, filterSPAM.id);
        statement.bindInt32Parameter(1, filterSPAM.rules[i].id);
        statement.execute();
        technalxs.simplemail.SimpleMailOverlay.storage.saveFilter(filterSPAM);
      }
    }
}

function deleteActionFilterSPAM() {
  var nameFilterSPAM = "SPAM";
  getSPAMFilterId(nameFilterSPAM);
  var filters = technalxs.simplemail.SimpleMailOverlay.storage.getFilters();
  for(var i in filters) {
    if (filters[i].id == nameFilterSPAMId) {
      filterSPAM = filters[i];
    }
  }
  if (typeof(filterSPAM) == 'undefined') {
    return;
  }

  initRules(filterSPAM.actions);

  var file = technalxs.simplemail.SimpleMailFile.getDataDirectory();
  file.append("simplemail.sqlite");
  var storageService = Components.classes["@mozilla.org/storage/service;1"]
                      .getService(Components.interfaces.mozIStorageService);
  var connection = storageService.openDatabase(file);
  var statement = connection.createStatement("DELETE FROM actions WHERE filterId=?1 AND id=?2");
  for (var i in filterSPAM.actions){
    statement.bindInt32Parameter(0, filterSPAM.id);
    statement.bindInt32Parameter(1, filterSPAM.actions[i].id);
    statement.execute();
    technalxs.simplemail.SimpleMailOverlay.storage.saveFilter(filterSPAM);
  }
}