if(typeof(technalxs) == "undefined") {var technalxs = {};};
if(typeof(technalxs.simplemail) == "undefined" ) {technalxs.simplemail = {};};

technalxs.simplemail.SimpleMailPreferences = function(){
  var pub = {};
  
  pub.accounts = [],
  pub.filters = [],
  pub.account = [],
  pub.messages = [],
       
  pub.initialize = function(){
    technalxs.simplemail.SimpleMailOverlay = technalxs.simplemail.SimpleMailUtils.getBrowserWindow().technalxs.simplemail.SimpleMailOverlay;
    technalxs.simplemail.SimpleMailPreferences.accounts = technalxs.simplemail.SimpleMailOverlay.storage.getAccounts();
    accountTree = technalxs.simplemail.SimpleMailDom.get("account-tree");
    accountTree.view = technalxs.simplemail.accountTreeView;
    if (accountTree.view.rowCount > 0) accountTree.view.selection.select(0);

    technalxs.simplemail.SimpleMailPreferences.filters = technalxs.simplemail.SimpleMailOverlay.storage.getFilters();
    filterTree = technalxs.simplemail.SimpleMailDom.get("filter-tree");
    filterTree.view = technalxs.simplemail.filterTreeView;
    if (filterTree.view.rowCount > 0) filterTree.view.selection.select(0);

    technalxs.simplemail.SimpleMailDom.get("checkOnStartup").checked = technalxs.simplemail.SimpleMailPrefs.getBool("checkOnStartup");
    technalxs.simplemail.SimpleMailDom.get("openInCurrentTab").checked = technalxs.simplemail.SimpleMailPrefs.getBool("openInCurrentTab");
    technalxs.simplemail.SimpleMailDom.get("moveToTrash").checked = technalxs.simplemail.SimpleMailPrefs.getBool("moveToTrash");
    technalxs.simplemail.SimpleMailDom.get("cleanonexit").checked = technalxs.simplemail.SimpleMailPrefs.getBool("cleanonexit");
    technalxs.simplemail.SimpleMailDom.get("confirmdelete").checked = technalxs.simplemail.SimpleMailPrefs.getBool("confirmdelete");
    technalxs.simplemail.SimpleMailDom.get("hideStatusNoMail").checked = technalxs.simplemail.SimpleMailPrefs.getBool("hideStatusNoMail");
    technalxs.simplemail.SimpleMailDom.get("hideNoMail").checked = technalxs.simplemail.SimpleMailPrefs.getBool("hideNoMail");
    technalxs.simplemail.SimpleMailDom.get("hideAll").checked = technalxs.simplemail.SimpleMailPrefs.getBool("hideAll");
    technalxs.simplemail.SimpleMailDom.get("headersOnly").checked = technalxs.simplemail.SimpleMailPrefs.getBool("headersOnly");
    technalxs.simplemail.SimpleMailDom.get("newMessagesInWindow").checked = technalxs.simplemail.SimpleMailPrefs.getBool("newMessagesInWindow");
    technalxs.simplemail.SimpleMailDom.get("addressBookAddOnSend").checked = technalxs.simplemail.SimpleMailPrefs.getBool("addressBookAddOnSend");
    technalxs.simplemail.SimpleMailDom.get("plaintextOnSend").checked = technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnSend");
    technalxs.simplemail.SimpleMailDom.get("plaintextOnReceive").checked = technalxs.simplemail.SimpleMailPrefs.getBool("plaintextOnReceive");
    technalxs.simplemail.SimpleMailDom.get("markReadTimeout").value = technalxs.simplemail.SimpleMailPrefs.getInt("markReadTimeout");
    technalxs.simplemail.SimpleMailUtils.selectItem("popupNotification", technalxs.simplemail.SimpleMailPrefs.getString("popupNotification"));
    technalxs.simplemail.SimpleMailUtils.selectItem("sendreceiptresp", technalxs.simplemail.SimpleMailPrefs.getString("sendreceiptresp"));
    technalxs.simplemail.SimpleMailDom.get("dataDirectory").value = technalxs.simplemail.SimpleMailPrefs.getString("dataDirectory");
    technalxs.simplemail.SimpleMailPrefs.getBool("transpopup") ?  technalxs.simplemail.SimpleMailDom.get("stylepopup").selectedIndex = 0
                                             : (technalxs.simplemail.SimpleMailPrefs.getBool("fullpopup") ? technalxs.simplemail.SimpleMailDom.get("stylepopup").selectedIndex = 1
                                             : technalxs.simplemail.SimpleMailDom.get("stylepopup").selectedIndex = 2); 
    technalxs.simplemail.SimpleMailDom.get("popupTimeout").value = technalxs.simplemail.SimpleMailPrefs.getInt("popupTimeout");
    technalxs.simplemail.SimpleMailPrefs.getBool("old") ?  technalxs.simplemail.SimpleMailDom.get("styleicons").selectedIndex = 0
                                             : technalxs.simplemail.SimpleMailPrefs.getBool("nuvola") ? technalxs.simplemail.SimpleMailDom.get("styleicons").selectedIndex = 1
                                             : (technalxs.simplemail.SimpleMailPrefs.getBool("oxygen") ? technalxs.simplemail.SimpleMailDom.get("styleicons").selectedIndex = 2
                                             : technalxs.simplemail.SimpleMailDom.get("styleicons").selectedIndex = 3);
    technalxs.simplemail.SimpleMailPrefs.getBool("eu") ?  technalxs.simplemail.SimpleMailDom.get("formatDate").selectedIndex = 0
                                             : technalxs.simplemail.SimpleMailDom.get("formatDate").selectedIndex = 1;
    technalxs.simplemail.SimpleMailDom.get("removeImages").checked = technalxs.simplemail.SimpleMailPrefs.getBool("removeImages");
    technalxs.simplemail.SimpleMailDom.get("newAttachs").checked = technalxs.simplemail.SimpleMailPrefs.getBool("newAttachs");
    technalxs.simplemail.SimpleMailDom.get("mailSound").checked = technalxs.simplemail.SimpleMailPrefs.getBool("mailSound");
    technalxs.simplemail.SimpleMailDom.get("mailSoundPath").value = technalxs.simplemail.SimpleMailPrefs.getString("mailSoundPath");
    technalxs.simplemail.SimpleMailDom.get("warningPlainText").checked = technalxs.simplemail.SimpleMailPrefs.getBool("warningPlainText");
    technalxs.simplemail.SimpleMailDom.get("cleandatabase").checked = technalxs.simplemail.SimpleMailPrefs.getBool("cleandatabase");
    technalxs.simplemail.SimpleMailDom.get("enableLog").checked = technalxs.simplemail.SimpleMailPrefs.getBool("enableLog");
    technalxs.simplemail.SimpleMailPrefs.getBool("messagesInWindow") ? technalxs.simplemail.SimpleMailDom.get("openMail").selectedIndex = 0
                                             : (technalxs.simplemail.SimpleMailPrefs.getBool("messagesInTab") ? technalxs.simplemail.SimpleMailDom.get("openMail").selectedIndex = 1
                                             : technalxs.simplemail.SimpleMailDom.get("openMail").selectedIndex = 2);
    technalxs.simplemail.SimpleMailDom.get("popupOnTop").checked = technalxs.simplemail.SimpleMailPrefs.getBool("popupOnTop");
    technalxs.simplemail.SimpleMailPreferences.showBrowseSoundDirectory();
    technalxs.simplemail.SimpleMailPreferences.statusDisabled();
  },
  
  pub.onSelectAccount = function() {
    technalxs.simplemail.SimpleMailDom.get("account-edit").disabled =
    technalxs.simplemail.SimpleMailDom.get("account-delete").disabled = !accountTree.view.selection.getRangeCount();
  },

  pub.editAccount = function(add) {
    if (add){
      technalxs.simplemail.SimpleMailPreferences.account = technalxs.simplemail.SimpleMailModel.SimpleMailAccount.create();
    } else {
      technalxs.simplemail.SimpleMailPreferences.account = technalxs.simplemail.SimpleMailPreferences.accounts[accountTree.currentIndex];
    }
    var param = { inn:{account: technalxs.simplemail.SimpleMailPreferences.account }, out: null};
    openDialog("chrome://simplemail/content/preferences/account.xul",
                "simplemail-preferences-account-window",
                "chrome,centerscreen,modal,resizable=no",param);
    
    var account = technalxs.simplemail.SimpleMailPreferences.account;

    if(param.out) {
      technalxs.simplemail.SimpleMailOverlay.storage.saveAccount(account);
      if (add) {
        technalxs.simplemail.SimpleMailPreferences.accounts.push(account);
        technalxs.simplemail.accountTreeView.treebox.rowCountChanged(technalxs.simplemail.accountTreeView.rowCount - 1, 1);
        accountTree.view.selection.select(technalxs.simplemail.accountTreeView.rowCount - 1);
      } else {
        technalxs.simplemail.accountTreeView.treebox.invalidateRow(accountTree.currentIndex);
      }
    }
  },

  pub.deleteAccounts = function() {
    var confirmText = technalxs.simplemail.SimpleMailBundle.getString("deleteAccounts");
    if (technalxs.simplemail.SimpleMailUtils.confirm(confirmText)) {
      technalxs.simplemail.accountTreeView.forEachSelected(function(index) {
        var ms = technalxs.simplemail.SimpleMailOverlay.storage.getAccountMessages(technalxs.simplemail.SimpleMailPreferences.accounts[index].id);
        technalxs.simplemail.SimpleMailPreferences.messages = technalxs.simplemail.SimpleMailPreferences.messages.concat(ms);
      });
      if (technalxs.simplemail.SimpleMailPreferences.messages.length) {
        var confirmText = technalxs.simplemail.SimpleMailBundle.getString("deleteAccountMessages");
        technalxs.simplemail.SimpleMailOverlay.askDeleteMail(technalxs.simplemail.SimpleMailPreferences.messages, confirmText, window);
      }
      technalxs.simplemail.accountTreeView.forEachSelected(function(index) {
        technalxs.simplemail.SimpleMailOverlay.storage.deleteAccount(technalxs.simplemail.SimpleMailPreferences.accounts[index]);
        technalxs.simplemail.SimpleMailPreferences.accounts.splice(index, 1);
        technalxs.simplemail.accountTreeView.treebox.rowCountChanged(index, -1);
      });
    }
  },

  pub.hideStatusNoMail = function(value) {
    technalxs.simplemail.SimpleMailPrefs.setBool('hideStatusNoMail', value);
    technalxs.simplemail.SimpleMailOverlay.updateIcons();
  },

  pub.hideNoMail = function(value) {
    technalxs.simplemail.SimpleMailPrefs.setBool('hideNoMail', value);
    technalxs.simplemail.SimpleMailOverlay.updateIcons();
  },

  pub.hideAll = function(value) {
    technalxs.simplemail.SimpleMailPrefs.setBool('hideAll', value);
    technalxs.simplemail.SimpleMailPreferences.statusDisabled();
    technalxs.simplemail.SimpleMailOverlay.updateIcons();
  },

  pub.statusDisabled = function () {
    if (technalxs.simplemail.SimpleMailPrefs.getBool("hideAll")) {
      technalxs.simplemail.SimpleMailDom.get("hideStatusNoMail").disabled = true;
      technalxs.simplemail.SimpleMailPrefs.clear('hideStatusNoMail');
    } else {
      technalxs.simplemail.SimpleMailDom.get("hideStatusNoMail").disabled = false;
      technalxs.simplemail.SimpleMailPrefs.clear('hideAll');
    }
  },

  pub.stylepopup = function(selectedIndex) {
    if (technalxs.simplemail.SimpleMailDom.get("stylepopup").selectedIndex == 0) {
      technalxs.simplemail.SimpleMailPrefs.setBool('transpopup', true);
      technalxs.simplemail.SimpleMailPrefs.setBool('fullpopup', false);
      technalxs.simplemail.SimpleMailPrefs.setBool('customPopup', true);
    }  
    else if (technalxs.simplemail.SimpleMailDom.get("stylepopup").selectedIndex == 1){
      technalxs.simplemail.SimpleMailPrefs.setBool('transpopup', false);
      technalxs.simplemail.SimpleMailPrefs.setBool('fullpopup', true);
      technalxs.simplemail.SimpleMailPrefs.setBool('customPopup', true);
    }
    else {
      technalxs.simplemail.SimpleMailPrefs.setBool('transpopup', false);
      technalxs.simplemail.SimpleMailPrefs.setBool('fullpopup', false);
      technalxs.simplemail.SimpleMailPrefs.setBool('customPopup', false);
    }
  },

  pub.browseDataDirectory = function() {
    var file = technalxs.simplemail.SimpleMailFile.chooseFile("folder");
    if (file) {
      technalxs.simplemail.SimpleMailDom.get("dataDirectory").value = file.path;
      technalxs.simplemail.SimpleMailPrefs.setString("dataDirectory", file.path);
    }
  },

  pub.defaultDataDirectory = function() {
    technalxs.simplemail.SimpleMailPrefs.clear("dataDirectory");
    technalxs.simplemail.SimpleMailDom.get("dataDirectory").value = technalxs.simplemail.SimpleMailPrefs.getString("dataDirectory");
  },

  pub.showBrowseSoundDirectory = function(){
    if (!technalxs.simplemail.SimpleMailPrefs.getBool("mailSound")) {
      technalxs.simplemail.SimpleMailDom.get("mailSoundPath").disabled = true;
      technalxs.simplemail.SimpleMailDom.get("browseMailSound").disabled = true;
    } else {
      technalxs.simplemail.SimpleMailDom.get("mailSoundPath").disabled = false;
      technalxs.simplemail.SimpleMailDom.get("browseMailSound").disabled = false;
    }
 },
  pub.browseSoundDirectory = function() {
    var file = technalxs.simplemail.SimpleMailFile.chooseFile("open", ["*.wav"]);
    if (file) {
      technalxs.simplemail.SimpleMailDom.get("mailSoundPath").value = file.path;
      technalxs.simplemail.SimpleMailPrefs.setString("mailSoundPath", file.path);
    }
  },

  pub.styleicons = function(selectedIndex) {
    if (technalxs.simplemail.SimpleMailDom.get("styleicons").selectedIndex == 0) {
      technalxs.simplemail.SimpleMailPrefs.setBool('old', true);
      technalxs.simplemail.SimpleMailPrefs.clear('nuvola');
      technalxs.simplemail.SimpleMailPrefs.clear('oxygen');
      technalxs.simplemail.SimpleMailPrefs.clear('australis');
    }  
    else if (technalxs.simplemail.SimpleMailDom.get("styleicons").selectedIndex == 1){
      technalxs.simplemail.SimpleMailPrefs.clear('old');
      technalxs.simplemail.SimpleMailPrefs.setBool('nuvola', true);
      technalxs.simplemail.SimpleMailPrefs.clear('oxygen');
      technalxs.simplemail.SimpleMailPrefs.clear('australis');
    }
    else if (technalxs.simplemail.SimpleMailDom.get("styleicons").selectedIndex == 2){
      technalxs.simplemail.SimpleMailPrefs.clear('old');
      technalxs.simplemail.SimpleMailPrefs.clear('nuvola');
      technalxs.simplemail.SimpleMailPrefs.setBool('oxygen', true);
      technalxs.simplemail.SimpleMailPrefs.clear('australis');
    }
    else if (technalxs.simplemail.SimpleMailDom.get("styleicons").selectedIndex == 3){
      technalxs.simplemail.SimpleMailPrefs.clear('old');
      technalxs.simplemail.SimpleMailPrefs.clear('nuvola');
      technalxs.simplemail.SimpleMailPrefs.clear('oxygen');
      technalxs.simplemail.SimpleMailPrefs.setBool('australis', true);
    }
  },

  pub.formatDate = function(selectedIndex) {
    if (technalxs.simplemail.SimpleMailDom.get("formatDate").selectedIndex == 0) {
      technalxs.simplemail.SimpleMailPrefs.setBool('eu', true);
      technalxs.simplemail.SimpleMailPrefs.clear('us');
    }  
    else if (technalxs.simplemail.SimpleMailDom.get("formatDate").selectedIndex == 1){
      technalxs.simplemail.SimpleMailPrefs.setBool('us', true);
      technalxs.simplemail.SimpleMailPrefs.clear('eu');
    }
  }, 

  pub.openMail = function(selectedIndex) {
    if (technalxs.simplemail.SimpleMailDom.get("openMail").selectedIndex == 0) {
      technalxs.simplemail.SimpleMailPrefs.setBool('messagesInWindow', true);
      technalxs.simplemail.SimpleMailPrefs.clear('messagesInTab');
    }  
    else if (technalxs.simplemail.SimpleMailDom.get("openMail").selectedIndex == 1){
      technalxs.simplemail.SimpleMailPrefs.clear('messagesInWindow');
      technalxs.simplemail.SimpleMailPrefs.setBool('messagesInTab', true);
    }
    else if (technalxs.simplemail.SimpleMailDom.get("openMail").selectedIndex == 2){
      technalxs.simplemail.SimpleMailPrefs.clear('messagesInTab');
      technalxs.simplemail.SimpleMailPrefs.clear('messagesInWindow');
    }
  },

  pub.helpWindow = null,
  
  pub.onHelp = function(){
    technalxs.simplemail.SimpleMailOverlay.helpWindow = window.open("http://www.userlogos.org/forum/simplemail");
  }, 

  pub.onAccept = function() {
    //console.error("onAccept: ", storage);//userok210

    if (!technalxs.simplemail.SimpleMailDom.get("mailSoundPath").value && technalxs.simplemail.SimpleMailDom.get("mailSound").checked) technalxs.simplemail.SimpleMailPrefs.setBool('mailSound', false); 

    if (technalxs.simplemail.SimpleMailDom.get("applyfilter").checked) {
      var storage = new technalxs.simplemail.SimpleMailStorageManager.SimpleMailStorage();
      //console.error("pref.onAccept: ", storage);//userok210

      var accounts = storage.getAccounts();
      var msg = new Array();
  
      for(var i = accounts.length - 1; i >= 0; i--) {   
        var selectedAccount = accounts[i];
        var msg = msg.concat(storage.getAccountMessages(selectedAccount.id));
      }
  
      if (msg) {
        var filterManager = new technalxs.simplemail.SimpleMailModel.SimpleMailFilterManager(storage,msg);
        var len = msg.length;
        var folders = storage.getFolders();
        
                
        for(var i = len - 1; i >= 0; i--) {
          for(var j in folders) {
            var children = folders[j];
            for (var k in children){
              if (children[k].id == msg[i].folderId) {
                var msgParentId = children[k].parentId;
              }
            }
          }

          if (msg[i].folderId == technalxs.simplemail.SimpleMailModel.SimpleMailFilter.INBOX | msgParentId == technalxs.simplemail.SimpleMailModel.SimpleMailFilter.INBOX)  {
            var msgsInbox = filterManager.execute(msg[i], technalxs.simplemail.SimpleMailModel.SimpleMailFilter.INBOX);
            storage.saveMessageState(msgsInbox);
          }
          if (msg[i].folderId == technalxs.simplemail.SimpleMailModel.SimpleMailFilter.SENT | msgParentId == technalxs.simplemail.SimpleMailModel.SimpleMailFilter.SENT)  {
            var msgsSent = filterManager.execute(msg[i], technalxs.simplemail.SimpleMailModel.SimpleMailFilter.SENT);
            storage.saveMessageState(msgsSent);
          }
        }
      }
    }
    technalxs.simplemail.SimpleMailPrefs.clear('applyfilter');
        
    var mainWindow = technalxs.simplemail.SimpleMailOverlay.getMainWindow(true);
    window.close();
    if (mainWindow) mainWindow.history.go();
  }
  return pub;
}();

technalxs.simplemail.accountTreeView = function(){
  var pub = {
    get rowCount() {
      return technalxs.simplemail.SimpleMailPreferences.accounts.length;
    }
  };
    
  pub.getCellText = function(row, column) {
    var name = column.id.replace(/account-/, "");
    return technalxs.simplemail.SimpleMailPreferences.accounts[row][name];
  },
  
  pub.getImageSrc = function(row, column) {
    if (column.id == "account-image") {
      return technalxs.simplemail.SimpleMailFile.getEnvelopeIconURL(technalxs.simplemail.SimpleMailPreferences.accounts[row].color);
    }
  },
  
  pub.action = function(){
    technalxs.simplemail.SimpleMailPreferences.editAccount();
  },
  
  pub.delete = function(){
    technalxs.simplemail.SimpleMailPreferences.deleteAccounts();
  },

  pub.canDrop = function(row, orientation) {
    return technalxs.simplemail.dragObserverPrefs.source == accountTree;
  },
  
  pub.drop = function(row, orientation) {
    if (orientation == technalxs.simplemail.accountTreeView.DROP_AFTER) {
      row++;
    }
    var move = new Array();
    technalxs.simplemail.accountTreeView.forEachSelected(function(index) {
      move.unshift(technalxs.simplemail.SimpleMailPreferences.accounts[index]);
      technalxs.simplemail.SimpleMailPreferences.accounts.splice(index, 1);
      technalxs.simplemail.accountTreeView.treebox.rowCountChanged(index, -1);
      if (index < row) row--;
    });
    technalxs.simplemail.SimpleMailPreferences.accounts.splice.apply(technalxs.simplemail.SimpleMailPreferences.accounts, [row, 0].concat(move));
    technalxs.simplemail.accountTreeView.treebox.rowCountChanged(row, move.length);
    technalxs.simplemail.SimpleMailOverlay.storage.saveAccounts(technalxs.simplemail.SimpleMailPreferences.accounts);

    technalxs.simplemail.dragObserverPrefs.source = null;
  },
  
  pub.getParentIndex = function(row) {
    return -1;
  }
  return pub;
}();  

technalxs.simplemail.DefaultTreeView.extend(technalxs.simplemail.accountTreeView);

technalxs.simplemail.filterTreeView = function(){
  var pub = {
    get rowCount() {
      return technalxs.simplemail.SimpleMailPreferences.filters.length;
    }
  };
  
  pub.getCellText = function(row, column) {
    var name = column.id.replace(/filter-/, "");
    var value = technalxs.simplemail.SimpleMailPreferences.filters[row][name];
    return technalxs.simplemail.SimpleMailBundle.getString(value) || value;
  },
  
  pub.action = function(){
    technalxs.simplemail.filterTreeView.editFilter();
  },
  
  pub.delete = function(){
    technalxs.simplemail.filterTreeView.deleteFilters();
  },

  pub.canDrop = function(row, orientation) {
    return technalxs.simplemail.dragObserverPrefs.source == filterTree;
  },
  
  pub.drop = function(row, orientation) {
    if (orientation == technalxs.simplemail.filterTreeView.DROP_AFTER) {
      row++;
    }
    var move = new Array();
    technalxs.simplemail.filterTreeView.forEachSelected(function(index) {
      move.unshift(technalxs.simplemail.SimpleMailPreferences.filters[index]);
      technalxs.simplemail.SimpleMailPreferences.filters.splice(index, 1);
      technalxs.simplemail.filterTreeView.treebox.rowCountChanged(index, -1);
      if (index < row) row--;
    });
    technalxs.simplemail.SimpleMailPreferences.filters.splice.apply(technalxs.simplemail.SimpleMailPreferences.filters, [row, 0].concat(move));
    technalxs.simplemail.filterTreeView.treebox.rowCountChanged(row, move.length);
    technalxs.simplemail.SimpleMailOverlay.storage.saveFilters(technalxs.simplemail.SimpleMailPreferences.filters);

    technalxs.simplemail.dragObserverPrefs.source = null;
  },
  
  pub.getParentIndex = function(row) {
    return -1;
  }
  return pub;
}();

technalxs.simplemail.DefaultTreeView.extend(technalxs.simplemail.filterTreeView);

technalxs.simplemail.filterTreeView.onSelectFilter = function() {
  technalxs.simplemail.SimpleMailDom.get("filter-edit").disabled =
  technalxs.simplemail.SimpleMailDom.get("filter-delete").disabled = !filterTree.view.selection.getRangeCount();
}

technalxs.simplemail.filterTreeView.editFilter = function(add) {
  var filter = add ? technalxs.simplemail.SimpleMailModel.SimpleMailFilter.create() : technalxs.simplemail.SimpleMailPreferences.filters[filterTree.currentIndex];
  var param = { filter: filter };

  openDialog("chrome://simplemail/content/preferences/filter/filter.xul",
             "simplemail-preferences-filter-window",
             "chrome,centerscreen,modal,resizable", param);
  if (!param.filter) return;

  technalxs.simplemail.SimpleMailOverlay.storage.saveFilter(filter);
  if (add) {
    technalxs.simplemail.SimpleMailPreferences.filters.push(filter);
    technalxs.simplemail.filterTreeView.treebox.rowCountChanged(technalxs.simplemail.filterTreeView.rowCount - 1, 1);
    filterTree.view.selection.select(technalxs.simplemail.filterTreeView.rowCount - 1);
  } else {
    technalxs.simplemail.filterTreeView.treebox.invalidateRow(filterTree.currentIndex);
  }
}

technalxs.simplemail.filterTreeView.deleteFilters = function() {
  if (technalxs.simplemail.SimpleMailUtils.confirm(technalxs.simplemail.SimpleMailBundle.getString("deleteFilter"))) {
    technalxs.simplemail.filterTreeView.forEachSelected(function(index) {
      technalxs.simplemail.SimpleMailOverlay.storage.deleteFilter(technalxs.simplemail.SimpleMailPreferences.filters[index]);
      technalxs.simplemail.SimpleMailPreferences.filters.splice(index, 1);
      technalxs.simplemail.filterTreeView.treebox.rowCountChanged(index, -1);
    });
  }
}

// Drag-n-Drop
technalxs.simplemail.dragObserverPrefs = function(){
  var pub = {};
  
  pub.source = null,
  
  pub.onDragStart = function(event, transferData, action) {
    if (event.target.nodeName != "treechildren") return;

    transferData.data = new TransferData();
    transferData.data.addDataForFlavour("text/unicode", "");
    technalxs.simplemail.dragObserverPrefs.source = event.target.parentNode;
  },
  
  pub.getSupportedFlavours = function () {
    var flavours = new FlavourSet();
    flavours.appendFlavour("text/unicode");
    return flavours;
  },
  
  pub.onDrop = function(event, transferData, session) {}
  
  return pub;
}();